                opt D+

* Test fr DSPMOD
* coderight by bITmASTER of BSW of CC *

                >PART 'equ'
; 26/08/93

iera            equ $fffffa07           ;Interrupt-Enable-Register A
ierb            equ $fffffa09           ;                                                               B
imra            equ $fffffa13
isra            equ $fffffa0f
isrb            equ $fffffa11
tacr            equ $fffffa19
tbcr            equ $fffffa1b
tadr            equ $fffffa1f
tbdr            equ $fffffa21
tccr            equ $fffffa1d
tcdr            equ $fffffa23
aer             equ $fffffa03
STColor         equ $ffff8240
FColor          equ $ffff9800
vbl             equ $70
timer_int       equ $0120
timer_c_int     equ $0114

ym_select       equ $ffff8800
ym_write        equ $ffff8802
ym_read         equ $ffff8800

vbaselow        equ $ffff820d
vbasemid        equ $ffff8203
vbasehigh       equ $ffff8201
vcountlow       equ $ffff8209
vcountmid       equ $ffff8207
vcounthigh      equ $ffff8205
linewid         equ $ffff820f
hscroll         equ $ffff8265

keyctl          equ $fffffc00
keybd           equ $fffffc02

DspHost         equ $ffffa200
HostIntVec      equ $03fc

PCookies        equ $05a0

hop             equ $ffff8a3a
op              equ $ffff8a3b
line_nr         equ $ffff8a3c
mode            equ $ffff8a3c
skew            equ $ffff8a3d
endmask1        equ $ffff8a28
endmask2        equ $ffff8a2a
endmask3        equ $ffff8a2c
x_count         equ $ffff8a36
y_count         equ $ffff8a38
dest_x_inc      equ $ffff8a2e
dest_y_inc      equ $ffff8a30
dest_adr        equ $ffff8a32
src_x_inc       equ $ffff8a20
src_y_inc       equ $ffff8a22
src_adr         equ $ffff8a24

mpx_src         equ $ffff8930
mpx_dst         equ $ffff8932
                endpart

* Adresse       Funktion                Input                Output
*-------------------------------------------------------------------------
* player+28:    install Player          d0: 0                -
* player+28+4:  de-install Player       -                    -
* player+28+8:  start Player            a0: Modul            d0: Playtime
*                                                            in BCD, z.B. $1234
*                                                            = 12 Min, 34 Sek
* player+28+12: stop Player             -                    -
* player+28+16: Player-Int ( 50 Hz )    -                    -
* player+28+20: dc.w MainVolume
*               0: max Volume
*               $40: Volume=0




                moveq   #0,d0
                bsr     player+28       ;install Player

                pea     init
                move.w  #$26,-(sp)
                trap    #14
                addq.l  #6,sp

                lea     mod1,a0
                bsr     play_mod
                lea     mod2,a0
                bsr     play_mod

                pea     off
                move.w  #$26,-(sp)
                trap    #14
                addq.l  #6,sp
                moveq   #2,d0

                bsr     player+28+4     ;aus

                clr.w   -(sp)
                trap    #1


play_mod:       >PART
                movea.l a0,a6
                pea     txt1
                move.w  #9,-(sp)
                trap    #1
                addq.l  #6,sp

                move.l  a6,-(sp)
                move.w  #9,-(sp)
                trap    #1
                addq.l  #6,sp

                movea.l a6,a0
                bsr     player+28+2*4
                move.w  d0,d7
                move.w  d7,d6
                and.w   #$ff,d6         ;d6 = Sekunden
                lsr.w   #8,d7
                and.w   #$ff,d7         ;d7 = Minuten


                pea     txt2
                move.w  #9,-(sp)
                trap    #1
                addq.l  #6,sp

                move.w  d7,d0
                bsr     print_bcd

                move.w  #":",-(sp)
                move.w  #2,-(sp)
                trap    #1
                addq.l  #4,sp

                move.w  d6,d0
                bsr     print_bcd

                bsr     print_time
                move.w  #1,timer50

wait_key:       move.w  #2,-(sp)
                move.w  #1,-(sp)
                trap    #13
                addq.l  #4,sp
                tst.w   d0
                bne.s   exit

                tst.w   timer50
                bne.s   wait_key

                move.w  d6,d0
                or.w    d7,d0
                beq.s   wait_key1       ;Timer ist Null

                move.b  #$99,d0
                abcd    d0,d6           ;Sekunden -1
                cmp.b   d0,d6           ;Unterlauf ?
                bne.s   wait_key1       ;nein
                move.w  #$59,d6         ;Sekunden = 59
                abcd    d0,d7           ;Minuten -1

wait_key1:      bsr     print_time
wait_s:         tst.w   timer50
                beq.s   wait_s
                bra     wait_key

exit:           move.w  #1,-(sp)
                trap    #1
                addq.l  #2,sp

                bsr     VolDown
                bsr     player+28+3*4   ;Stop

                rts
                endpart

txt1:           dc.b $1b,"E","now playing: ",0
txt2:           dc.b $1b,"Y",32,40+32,"Play-Time: ",0
txt3:           dc.b $1b,"Y",32,60+32,0
                even

print_bcd:      >PART
                move.l  d0,-(sp)
                move.l  d0,-(sp)
                lsr.w   #4,d0
                and.w   #$0f,d0
                add.w   #$30,d0
                move.w  d0,-(sp)
                move.w  #2,-(sp)
                trap    #1
                addq.l  #4,sp
                move.l  (sp)+,d0
                and.w   #$0f,d0
                add.w   #$30,d0
                move.w  d0,-(sp)
                move.w  #2,-(sp)
                trap    #1
                addq.l  #4,sp
                move.l  (sp)+,d0
                rts
                endpart

print_time:     >PART
                pea     txt3
                move.w  #9,-(sp)
                trap    #1
                addq.l  #6,sp

                move.w  d7,d0           ;Minuten
                bsr     print_bcd

                move.w  #":",-(sp)
                move.w  #2,-(sp)
                trap    #1
                addq.l  #4,sp

                move.w  d6,d0           ;Sekunden
                bsr     print_bcd
                rts
                endpart

VolDown:        >PART
                lea     player+28+5*4,a0 ;Main-Volume
                moveq   #0,d0
vol_down1:      bsr     wait
                move.w  d0,(a0)
                addq.w  #1,d0
                cmp.w   #$50,d0
                bne.s   vol_down1
                rts
                endpart

timer_b:        movem.l d0-a6,-(sp)
                bsr     player+28+4*4
                move.w  timer50,d0
                addq.w  #1,d0
                cmp.w   #50,d0
                bne.s   timer_b1
                clr.w   d0
timer_b1:       move.w  d0,timer50
                movem.l (sp)+,d0-a6
                bclr    #0,$fffffa0f.w
                addq.w  #1,count
                rte

init:           lea     SaveArea,a0
                move.l  timer_int.w,(a0)+
                move.b  tbcr.w,(a0)+
                move.b  tbdr.w,(a0)+
                move.b  #246,tbdr.w
                move.b  #7,tbcr.w
                move.l  #timer_b,timer_int.w
                bset    #0,imra.w

                bset    #0,iera.w
                rts

off:            bclr    #0,iera.w
                bclr    #0,imra.w
                lea     SaveArea,a0
                move.l  (a0)+,timer_int.w
                move.b  (a0)+,tbcr.w
                move.b  (a0)+,tbdr.w
                rts


wait:           move.l  d0,-(sp)
                move.w  count,d0
                addq.w  #3,d0
wait1:          cmp.w   count,d0
                bne.s   wait1
                move.l  (sp)+,d0
                rts

                data

timer50:        dc.w 0

                path 'C:\DSP_MOD\'
player:         ibytes 'DSPMOD.BSW'
                path 'D:\MOD\'
mod1:           ibytes 'MOD4.MOD'
mod2:           ibytes 'MOD5.MOD'

                bss

count:          ds.w 1
SaveArea:       ds.b 6

                end
